/*
 *  main_PSX.i - Main program, PSX specific stuff
 *
 *  Frodo (C) 1994-1997 Christian Bauer
 */

#include <libps.h>
#include <MWDebugIO.h>


// Global variables
Frodo *be_app;	// Pointer to Frodo object


/*
 *  Create application object and start it
 */

int main(void)
{
	srand(0);	// !!

	be_app = new Frodo();
	be_app->ReadyToRun();
	delete be_app;

	return 0;
}


/*
 *  Constructor: Initialize member variables
 */

Frodo::Frodo()
{
	TheC64 = NULL;
	prefs_path[0] = 0;
}


/*
 *  Arguments processed, run emulation
 */

void Frodo::ReadyToRun(void)
{
/*
	// Load preferences
	if (!prefs_path[0])
		strcpy(prefs_path, "Frodo Prefs");
	ThePrefs.Load(prefs_path);

	// Show preferences editor
	if (ThePrefs.ShowEditor(TRUE, prefs_path)) {

		// Create and start C64
		TheC64 = new C64;
		if (load_rom_files())
			TheC64->Run();
		delete TheC64;
	}
*/
}


/*
 *  Load C64 ROM files
 */

bool Frodo::load_rom_files(void)
{
	MWbload("Basic ROM", TheC64->Basic);
	MWbload("Kernal ROM", TheC64->Kernal);
	MWbload("Char ROM", TheC64->Char);
	MWbload("1541 ROM", TheC64->ROM1541);
}
