/*
** Dialog functions
**
** Copyright  1997 Marko Mkel, see COPYING.LIB for details
*/

/* Dialog return values */
typedef enum { btUnspecified, btYes, btNo, btOk, btCancel } Choice;

/* Dialog buttons.  Combine these with bitwise or. */
#define BT_YES (1 << btYes)
#define BT_NO (1 << btNo)
#define BT_OK (1 << btOk)
#define BT_CANCEL (1 << btCancel)

/* Open a dialog with the specified message and buttons */
Choice Dialog (Widget parent, const char *name, unsigned whichButtons);

/* Ask an integer value in the specified dialog */
Boolean Ask (Widget parent, const char *name, long *value, long min, long max);
