/*
** Initialize the X11 user interface
**
** Copyright  1997 Marko Mkel, see COPYING.LIB for details
*/

/* The top level widget */
extern Widget TopLevel;

#define COLORS 16

/* Application resources */
typedef struct {
  String pausedString;
  String commandString;
  String romPath;
  String filePath;
  String kernalRom;
  String basicRom;
  String characterRom;
  String exRom;
  String driveRom;
  String color[COLORS];
  String keyRestore;
  String keyShiftL;
  String keyShiftR;
  String joy1North;
  String joy1Northeast;
  String joy1East;
  String joy1Southeast;
  String joy1South;
  String joy1Southwest;
  String joy1West;
  String joy1Northwest;
  String joy1Fire;
  String joy2North;
  String joy2Northeast;
  String joy2East;
  String joy2Southeast;
  String joy2South;
  String joy2Southwest;
  String joy2West;
  String joy2Northwest;
  String joy2Fire;
  Boolean privateColormap;
  Boolean mitShm;
  Boolean cache;
  Boolean xsync;
  Boolean fixTop;
  Boolean fixLeft;
  Boolean paused;
  Boolean emulate1541;
  Boolean exrom;
  Boolean joy1;
  Boolean joy2;
  Boolean confirmExit;
  int topLine;
  int bottomLine;
  int leftColumn;
  int rightColumn;
  int fixTopLine;
  int fixLeftColumn;
  int speed;
  int driveLed;
  int horizBlock;
  int vertBlock;
  int frameParts;
  int frameSkip;
  Visual *visual;
  int depth;
} AppResources;

extern AppResources appResources;

/* Flag: has the application been closed? */
extern Boolean closed;

/* Event handler definition macro */
#define EventHandler(name)\
static void name (Widget w, XtPointer closure, XEvent *event, Boolean *cont)

/* Initialize the application. */
struct _Menu;
Boolean InitializeXt (XtAppContext *appContext, String ClassName,
		      String fallbackRes[],
		      struct _Menu **menus,
		      int width, int height,
		      int *argc, char **argv);

/* Convert a line of graphics to the image */
extern void (*convertLine) (unsigned gfx[], unsigned line);

/* Display a line of graphics (buffered) */
void displayLine (unsigned line);

/* Update the main window */
void UpdateMainWindow ();

/* Perform cleanup */
void Cleanup ();

/* Return any text pasted to the emulator window */
char *GetCommands ();
