/*
** Menu interface
**
** Copyright  1997 Marko Mkel, see COPYING.LIB for details
*/

/* Menu entry types */
typedef enum {
  menuSeparator, menuNormal, menuCheckable
} MenuType;

/*
 * Menu handler function.  If flag is not set, the handler will
 * return the menu selection state.  If it is set, the handler will
 * perform the menu action and return whether the operation succeeded.
 */
typedef Boolean MenuHandler (Boolean flag);

struct _Menu;

typedef struct _MenuEntry {
  MenuType type;
  char *name;
  MenuHandler (*function);
  struct _Menu *submenu;
  Widget widget;
} MenuEntry;

typedef struct _Menu {
  char *name;
  struct _MenuEntry *entries;
  Cardinal num_entries;
  Widget widget;
  Widget activeSubmenu;
} Menu;

/* Create the menus */
Boolean CreateMenus (Widget parent, Menu **menus);

/* Update the checkable menu entries */
void UpdateMenus ();
